Bug 227372 - Cannot view or change download actions due to lack of extensions
Cannot view or change download actions due to lack of extensions
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: firefox (Show other bugs)
6
All Linux
medium Severity high
: ---
: ---
Assigned To: Christopher Aillon
: Patch
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-02-05 12:36 EST by Philip Spencer
Modified: 2008-01-15 09:39 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-01-15 09:39:46 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch to alleviate problem (applies to the FC6-patched source tree) (1.79 KB, patch)
2007-02-05 12:36 EST, Philip Spencer
no flags Details | Diff

  None (edit)
Description Philip Spencer 2007-02-05 12:36:06 EST
Description of problem:

If a user checks the "Do this automatically from now on" box when opening
a downloaded file with a helper application, there is no apparent way to
ever reverse that decision. The indicated action does not appear when
you click "View/Edit Actions" in the Downloads preferences -- indeed, that
list is always empty.

Version-Release number of selected component (if applicable):

1.5.0.9-2.fc6

How reproducible:

Always.

Steps to Reproduce:
1. Start with default firefox configuration on a new Fedora Core installation
(make sure user does not have a preexisting mimeTypes.rdf file).
2. Click on a link to a pdf file.
3. Select a helper application.
4. Check the "Do this automatically from now on" box.
5. Complete the download.
6. Go to Edit->Preferences, select Downloads tab, and click on View/Edit Actions.

Actual results:

You see an empty list, with no way to undo or reverse the selection of
automatically using that helper application for pdf files.

Expected results:

You should see a list containing your selected helper application for pdf files,
with the option to edit or remove that automatic action.

Additional info:

The reason is because GNOME has now deprecated all functions that return
extensions for MIME types, and firefox is configured by default to hide all
actions for MIME types without extensions.

Firefox calls gnome_vfs_mime_get_extensions_list (in 
mozilla/uriloader/exthandler/unix/nsGNOMERegistry.cpp) to get the list of
extensions for a MIME type. However, in current versions of GNOME that function
is hardcoded to always return NULL, so all MIME types now have an empty
extension list in firefox (except for ones left over in a user's mimeTypes.rdf
file from running previous versions of firefox with earlier versions of GNOME).

The firefox configuration by default sets the
"browser.download.hide_plugins_without_extensions" preference (which applies to
helper apps as well as to plugins). Therefore, all actions are hidden and the
user cannot reverse or undo the action.

I have attached a patch which alleviates the problem by removing the default
setting of browser.download.hide_plugins_without_extensions, as well as
removing the "Extensions" column from the initial view of the action list
(though the user can add it back again using the column picker) and using the
file type description instead of extension as the primary field.

This won't solve the problem for anyone who has explicitly set
browser.download.hide_plugins_without_extensions in their user preferences file,
so the real solution is probably to change the code to ignore that setting.

Alternatively, one could come up with an alternative method for getting a list
of extensions, but presumably GNOME made a deliberate choice to remove this
functionality so there is presumably a good reason for it and it is probably
better to adapt firefox-for-unix to no longer rely on extensions. Of course,
firefox for windows will still need them, so any patch will have to be
unix-specific (or maybe even linux-specific) with appropriate #ifdef's if
pushed into the upstream firefox tree. I don't know enough about firefox
development to know what those #ifdefs should be, so have not attempted such a
patch.
Comment 1 Philip Spencer 2007-02-05 12:36:06 EST
Created attachment 147376 [details]
Patch to alleviate problem (applies to the FC6-patched source tree)
Comment 2 Martin Stransky 2007-02-14 10:30:47 EST
An upstream dupe was created here:
https://bugzilla.mozilla.org/show_bug.cgi?id=370386
Comment 3 Matěj Cepl 2007-12-10 04:24:29 EST
Fedora Core 6 is no longer supported, could you please reproduce this with the
updated version of the currently supported distribution (Fedora 7, 8, or
Rawhide)? If this issue turns out to still be reproducible, please let us know
in this bug report. If after a month's time we have not heard back from you, we
will have to close this bug as CANTFIX.

Setting status to NEEDINFO, and awaiting information from the reporter.

[This is mass-filed message to all open Fedora Core 6 bugs related to Xorg or
Gecko. If you see any other reason, why this bug shouldn't be closed, please,
comment on it here.]
Comment 4 Matěj Cepl 2008-01-15 09:39:46 EST
Since there are insufficient details provided in this report for us to
investigate the issue further, and we have not received feedback to the
information we have requested above, we will assume the problem was not
reproducible, or has been fixed in one of the updates we have released for the
reporter's distribution.

Users who have experienced this problem are encouraged to upgrade to the latest
update of their distribution, and if this issue turns out to still be
reproducible in the latest update, please reopen this bug with additional
information.

Closing as INSUFFICIENT_DATA.

{This is mass-closing of all obsolete bugs; if this bug was in your opinion
closed by mistake, please, reopen it with additional information; thanks a lot
and I am sorry for bothering you in such case.}

Note You need to log in before you can comment on or make changes to this bug.